/* ஢ઠ/८ࠧ 뫮,   HTML-䠩 */
/* Copyright (C) Vladimir Komarov aka Double W */

/* ॣ஧ᨬ ஢ઠ -  Win32  ࠡ⠥*/
Options.IgnoreCase = 1
/* ஢ઠ 譨 뫮 */
Options.CheckExternal = 0


/*
  main
*/

parse upper source _system _caller _commandname
parse arg args
if pos('"',args)=0 then parse var args infile
else parse var args '"' infile '"'
if length(infile)=0 then do
  say 'Usage: ' || substr(_commandname,lastpos('\',_commandname)+1) || ' <infile>'
  exit
  end

say 
say 'Checking "' || infile || '"...'

if length(stream(infile, 'c', 'QUERY EXISTS'))=0 then do
  say 'Cannot open source file' 
  exit
  end

curline = 0
buf = ''
do while lines(infile)>0
  cur = linein(infile)
  curline = curline+1

  buf = buf || ' ' || strip(cur,'T')
  parse var buf linestart '<' tag '>' lineend
  do while length(lineend)>0
    if length(lineend)>0 then call analyze_tag tag
    buf = lineend
    parse var buf linestart '<' tag '>' lineend
    end
  if substr(buf,length(buf),1)='>' then call analyze_tag tag
  else iterate
  buf = lineend
  end
exit


/*
   ⠣, ஢ઠ  뫮
*/
analyze_tag: procedure expose curline options.
  tag = ARG(1)
  parse upper var tag tagname taginfo
  select
    when tagname='A' then rc = check_reference(tag, 'HREF')
    when tagname='IMG' then rc = check_reference(tag, 'SRC')
    when tagname='BODY' then rc = check_reference(tag, 'BACKGROUND')
    otherwise rc = '';
    end
  if length(rc)>0 then say 'Line ' || curline || ': ' || rc
  return


/*
  ࠧ ⠣  ஢ઠ 饩   뫪
*/
check_reference: procedure expose options.
  tag = ARG(1)
  xref = ARG(2)
  interpret 'parse upper var tag before ''' || xref || '''i1 ''='' after'
  after = strip(substr(tag,length(tag)-length(after)+1))
  if length(after)=0 then return ''
  if substr(after,1,1)='"' then parse var after '"' url '"' i1
  else parse var after url i1
  parse var url i1 ':' addr
  parse upper var i1 protocol
  if length(addr)>0 then do /* absolute link */
    select
      when \Options.CheckExternal then return ''
      when protocol='MAILTO' then return ''
      otherwise return 'External link: ' || url
      end
    end
  parse var url fname '#' anchor
  if (length(fname)=0) & (length(anchor)>0) then return '' /* local link */
  if (length(fname)=0) then return 'Empty link' /* empty link */
  rc = stream(fname,'c','query exists')
  if length(rc)=0 then return 'Invalid file: ' || fname
  return ''
